<template>
  <div
    id="resourcecontentview"
    @dragenter="dragEnter"
    @dragleave="dragLeave"
    @dragend="dragLeave"
    @dragover.prevent=""
    @drop.prevent="uploadDrop"
  >
    <div
      class="droppable"
      v-if="
        showDroppable &&
        !resourceContentSettings.readOnly &&
        !resourceContentSettings.metadataView.editableDataUrl
      "
    >
      <p class="droppableText">{{ $t("canDropFile") }}</p>
    </div>
    <coscine-headline v-show="!isFullscreen" :headline="$t('resources')" />
    <b-form-file
      ref="fileTrigger"
      multiple
      v-model="fileListUploadSelect"
      class="mt-3"
      plain
    ></b-form-file>
    <span id="filesViewSpan">
      <div id="filesViewCard" :class="isFullscreen == false ? 'card' : ''">
        <div :class="isFullscreen == false ? 'card-body' : ''">
          <FilesView
            ref="filesView"
            :resource="resource"
            :resourceId="resourceId"
            :projectId="projectId"
            :folder="folder"
            :currentFolder="currentFolder"
            :resourceName="resourceName"
            :progressbarOccupied="progressbarOccupied"
            :canEditResource="canEditResource"
            :locale="locale"
            :applicationProfile="applicationProfile"
            :userId="userId"
            :isUploading="isUploading"
            :fileListEdit="fileListEdit"
            :resourceContentSettings="resourceContentSettings"
            @showDetail="setShowDetail"
            @currentFolder="setCurrentFolder"
            @folder="setFolder"
            @fileInfo="setFileInfo"
            @fileListEdit="setFileListEdit"
            @clickFileSelect="clickFileSelect"
          />
        </div>
      </div>
    </span>
    <div
      id="metadataManagerDiv"
      :class="isMetadataManagerHidden == true ? 'hiddenMetadataManager' : ''"
    >
      <b-button
        v-show="isFullscreen"
        squared
        id="metadataManagerToggleFullscreen"
        @click="toggleMenu()"
        ><span>{{ $t("metadataManager") }}</span></b-button
      >
      <div class="card">
        <div class="card-body">
          <MetadataManager
            :resourceId="resourceId"
            :resource="resource"
            :fileInfo="fileInfo"
            :showDetail="showDetail"
            :fileListEdit="fileListEdit"
            :fileListUpload="fileListUpload"
            :folder="folder"
            :currentFolder="currentFolder"
            :applicationProfile="applicationProfile"
            :applicationProfileId="applicationProfileId"
            :isUploading="isUploading"
            :resourceContentSettings="resourceContentSettings"
            @removeSelection="removeSelection"
            @isUploading="setIsUploading"
            @waitingForResponse="setWaitingForResponse"
            @fileInfo="setFileInfo"
            @fileListEdit="setFileListEdit"
            @clickFileSelect="clickFileSelect"
          />
          <div
            id="toggleFullscreenButton"
            :class="
              isMetadataManagerHidden == true ? '' : 'hiddenMetadataManager'
            "
          >
            <button
              v-if="isFullscreen"
              class="material-icons btn btn-secondary"
              type="button"
              @click="toggleFullscreen"
            >
              fullscreen_exit
            </button>
            <button
              v-else
              type="button"
              class="material-icons btn btn-secondary"
              @click="toggleFullscreen"
            >
              fullscreen
            </button>
          </div>
        </div>
      </div>
    </div>
    <coscine-loading-spinner
      :isWaitingForResponse="isWaitingForResponse"
    ></coscine-loading-spinner>
  </div>
</template>

<script lang="ts">
import Vue from "vue";
import FilesView from "./components/FilesView.vue";
import MetadataManager from "./components/MetadataManager.vue";

import { LanguageUtil, GuidUtil, MergeUtil } from "@coscine/app-util";
import {
  ResourceApi,
  ResourceTypeApi,
  BlobApi,
  ProjectRoleApi,
  MetadataApi,
  UserApi,
} from "@coscine/api-connection";
import {
  CoscineLoadingSpinner,
  CoscineHeadline,
} from "@coscine/component-library";
import "@coscine/component-library/dist/index.css";

import { EntryDefinition } from "@/utils/EntryDefinition";
import { DefaultResourceContentSettings } from "./utils/DefaultResourceContentSettings";
import ResourceContentSettings from "@/global";

import { v4 as uuidv4 } from "uuid";

export default Vue.extend({
  name: "resourcecontentview",
  data() {
    return {
      locale: "en",
      resourceId: "",
      projectId: "",
      resource: {
        //---add flag for archived resources---
        Archived: false,
        //--------------------------------------
        ResourceName: "",
        DisplayName: "",
        Description: "",
        PID: "",
        Disciplines: [] as Array<unknown>,
        Keywords: [] as Array<unknown>,
        Visibility: {
          id: "",
          displayName: "",
        },
        License: null,
        UsageRights: "",
        type: {
          id: "",
          displayName: "",
          enabled: true,
        },
        applicationProfile: "",
        fixedValues: {},
        resourceTypeOption: {},
      },
      resourceName: "",
      isWaitingForResponse: false,
      fileInfo: {},
      fileListEdit: [] as EntryDefinition[],
      showDetail: false,
      fileListUpload: [] as EntryDefinition[],
      fileListUploadSelect: [] as File[],
      folder: [] as EntryDefinition[],
      currentFolder:
        window.location.hash.indexOf("#") !== -1
          ? window.location.hash.substring(1)
          : "/",
      applicationProfileId: "",
      showDroppable: false,
      dragCounter: 0,
      applicationProfile: [] as any[],
      userId: "",
      progressbarOccupied: 0,
      windowWidth: 0,
      windowHeight: 0,
      canEditResource: false,
      isFullscreen: false,
      isMetadataManagerHidden: false,
      isUploading: false,
      resourceContentSettings:
        new DefaultResourceContentSettings() as ResourceContentSettings,
    };
  },
  watch: {
    fileListUploadSelect() {
      for (const file of this.fileListUploadSelect) {
        this.fileListUpload.push({
          path: this.currentFolder,
          version: "1.0.0",
          uploading: false,
          info: file,
          name: file.name,
          size: file.size,
          metadata: {},
          isFolder: false,
          absolutepath: this.currentFolder + file.name,
        });
      }
      (this.$refs.filesView as any).$refs.adaptTable.clearSelected();
      this.showDetail = false;
    },
  },
  created() {
    this.locale = LanguageUtil.getLanguage();

    this.resourceId = GuidUtil.getResourceId();
    this.projectId = GuidUtil.getProjectId();
    if (GuidUtil.isValidGuid(this.resourceId)) {
      UserApi.getUser((response: any) => {
        this.userId = response.data.id;
      });
      ResourceApi.getResourceInformation(this.resourceId, (response: any) => {
        const data = response.data;
        this.resourceName = data.displayName;
        this.applicationProfileId = data.applicationProfile;
        this.resource.ResourceName = data.resourceName;
        this.resource.DisplayName = data.displayName;
        this.resource.Description = data.description;
        this.resource.UsageRights = data.usageRights;
        this.resource.Archived = data.archived;
        this.resource.Keywords = [] as Array<unknown>;
        const keywords = data.keywords ? data.keywords.split(";") : [];
        this.resource.Keywords = keywords;
        this.resource.Disciplines = [] as Array<unknown>;
        for (const discipline of Object.keys(data.disciplines)) {
          this.resource.Disciplines.push(data.disciplines[discipline]);
        }
        this.resource.Visibility = data.visibility;
        this.resource.PID = data.pid;
        this.resource.License = data.license;
        this.resource.type = data.type;
        this.resource.resourceTypeOption = data.resourceTypeOption;
        if ((this.resource.resourceTypeOption as any).Size != null) {
          BlobApi.getQuota(this.resourceId, (responseQuota: any) => {
            this.progressbarOccupied = responseQuota.data.data.usedSizeByte;
          });
          (this.resource.resourceTypeOption as any).Size =
            (this.resource.resourceTypeOption as any).Size * 1024 * 1024 * 1024;
        }
        this.resource.applicationProfile =
          data.applicationProfile !== null ? data.applicationProfile : "";
        this.resource.fixedValues =
          data.fixedValues !== null ? data.fixedValues : {};
        ResourceTypeApi.getResourceType(
          (this.resource.type as any).id,
          (resourceTypeResponse: any) => {
            this.resourceContentSettings = resourceTypeResponse.data
              .resourceContent as ResourceContentSettings;
            const languageStrings = (window as any).coscine.i18n
              .resourcecontentview[LanguageUtil.getLanguage()];
            // depending on the resource type information merge the appropriate strings
            if (
              languageStrings[resourceTypeResponse.data.displayName] !==
              undefined
            ) {
              (window as any).coscine.i18n.resourcecontentview[
                LanguageUtil.getLanguage()
              ] = MergeUtil.merge(
                MergeUtil.merge({}, languageStrings),
                languageStrings[resourceTypeResponse.data.displayName]
              );
            }
          }
        );
        MetadataApi.getProfile(
          this.applicationProfileId,
          (responseApplicationProfile: any) => {
            this.applicationProfile = responseApplicationProfile.data;
          }
        );
      });
      // should get the free/occupied space for the reasource here and hand it to the other templates?
      ResourceApi.isUserResourceCreator(
        this.resourceId,
        (response: any) =>
          (this.canEditResource = response.data.isResourceCreator)
      );
      ProjectRoleApi.getUserRoles(this.projectId, (response: any) => {
        response.data.forEach((userRole: any) => {
          if (userRole.role.displayName.toLowerCase() === "owner") {
            this.canEditResource = true;
          }
        });
      });
    }
  },
  mounted() {
    this.$nextTick(function () {
      window.addEventListener("resize", this.getWindowWidth);
      window.addEventListener("resize", this.getWindowHeight);

      this.getWindowWidth();
      this.getWindowHeight();
    });
  },
  methods: {
    clickFileSelect() {
      this.showDetail = false;
      if (this.resourceContentSettings.metadataView.editableDataUrl) {
        this.fileListEdit.length = 0;
        this.fileListUpload.length = 0;
        this.fileListUpload.push({
          id: uuidv4(),
          path: "",
          version: "1.0.0",
          uploading: false,
          name: "",
          metadata: {},
          isFolder: false,
          absolutepath: this.currentFolder,
        });
      } else {
        (this.$refs.fileTrigger as any).$el.click();
      }
    },
    dragEnter() {
      this.dragCounter++;
      this.showDroppable = true;
    },
    dragLeave() {
      this.dragCounter--;
      if (this.dragCounter === 0) {
        this.showDroppable = false;
      }
    },
    uploadDrop(ev: DragEvent) {
      if (
        !this.resourceContentSettings.readOnly &&
        !this.resourceContentSettings.metadataView.editableDataUrl
      ) {
        this.dragCounter = 0;
        this.showDroppable = false;
        if (ev?.dataTransfer?.items) {
          for (const item of ev.dataTransfer.items) {
            if (item.kind === "file") {
              const file = item.getAsFile();
              if (file !== null) {
                this.fileListUpload.push({
                  path: this.currentFolder,
                  version: "1.0.0",
                  uploading: false,
                  info: file,
                  name: file.name,
                  size: file.size,
                  metadata: {},
                  isFolder: false,
                  absolutepath: this.currentFolder + file.name,
                });
              }
            }
          }
          (this.$refs.filesView as any).$refs.adaptTable.clearSelected();
          this.showDetail = false;
        }
      }
    },
    setShowDetail(newShowDetail: boolean) {
      this.showDetail = newShowDetail;
    },
    setWaitingForResponse(newIsWaitingForResponse: boolean) {
      this.isWaitingForResponse = newIsWaitingForResponse;
    },
    setIsUploading(newIsUploading: boolean) {
      this.isUploading = newIsUploading;
    },
    setCurrentFolder(newCurrentFolder: string) {
      this.currentFolder = newCurrentFolder;
    },
    setFolder(newFolder: EntryDefinition[]) {
      this.folder = newFolder;
    },
    setFileInfo(newFileInfo: any) {
      this.fileInfo = newFileInfo;
    },
    setFileListEdit(newFileListEdit: EntryDefinition[]) {
      this.fileListEdit = newFileListEdit;
    },
    removeSelection(selectionRemovable: Array<unknown>) {
      const table = (this.$refs.filesView as any).$refs.adaptTable;
      for (let i = 0; i < table.items.length; i++) {
        const item = table.items[i];
        if (
          selectionRemovable.filter((entry: any) => entry.name === item.name)
            .length > 0
        ) {
          table.unselectRow(i);
        }
      }
    },
    setFullscreen(newIsFullscreen: boolean) {
      this.isFullscreen = newIsFullscreen;
      if (newIsFullscreen) {
        document.body.classList.add("fullscreen");
        document.body.classList.remove("show-menu");
      } else {
        document.body.classList.remove("fullscreen");
        this.isMetadataManagerHidden = false;
        if (localStorage.getItem("isSidebarVisible") === "1") {
          document.body.classList.add("show-menu");
        }
      }
    },
    toggleFullscreen() {
      this.setFullscreen(!this.isFullscreen);
    },
    toggleMenu() {
      this.$set(this, "isMetadataManagerHidden", !this.isMetadataManagerHidden);
    },
    getWindowWidth() {
      this.windowWidth = document.documentElement.clientWidth;
      if (this.windowWidth < 1250) {
        this.setFullscreen(true);
      } else {
        this.setFullscreen(false);
      }
    },
    getWindowHeight() {
      this.windowHeight = document.documentElement.clientHeight;
    },
  },
  components: {
    FilesView,
    MetadataManager,
    CoscineHeadline,
    CoscineLoadingSpinner,
  },
});
</script>

<style>
#resourcecontentview {
  position: relative;
  height: calc(100vh - 40px - 35px - 20px - 20px - 20px);
  margin-bottom: 20px;
}
body.fullscreen #resourcecontentview {
  position: absolute;
  top: 90px;
  left: 0px;
  right: 0px;
  bottom: 0px;
  height: auto;
}
body.fullscreen #resourcecontentview .DataSource .headerRow {
  margin-left: 0px;
  margin-right: 0px;
}
#resourcecontentview #filesViewSpan {
  position: absolute;
  right: 620px;
  left: 0px;
}
#resourceview h4 {
  color: #000;
  font-family: "Avenir", Helvetica, Arial, sans-serif;
}
body.fullscreen #footer {
  display: none;
}
#footer {
  -webkit-transition: all 0.3s linear;
  transition: all 0.3s linear;
}
#metadataManagerDiv {
  position: absolute;
  right: 10px;
  width: 600px;
  background-color: rgb(253, 252, 251);
  -webkit-transition: all 0.3s linear;
  transition: all 0.3s linear;
}
body.fullscreen #metadataManagerDiv {
  position: fixed;
  bottom: 0px;
  top: 78px;
  right: 0px;
}
body.fullscreen #metadataManagerDiv .card {
  border: 1px solid rgba(0, 0, 0, 0);
  height: 100%;
}
body.fullscreen #metadataManagerDiv.hiddenMetadataManager {
  right: -600px !important;
}
#metadataManagerToggleFullscreen {
  margin-left: -28px;
  line-height: 11px;
  position: absolute;
  top: -8px;
  bottom: -8px;
  width: 2em;
  min-width: 2em;
  padding: 0px;
}
#metadataManagerToggleFullscreen span {
  display: inline-block;
  transform: rotate(-90deg);
  -webkit-transform: rotate(-90deg);
  -moz-transform: rotate(-90deg);
  -ms-transform: rotate(-90deg);
  -o-transform: rotate(-90deg);
  white-space: nowrap;
  margin-left: -61px;
}
#toggleFullscreenButton button {
  padding: 3px;
  min-width: auto;
}
#toggleFullscreenButton {
  position: absolute;
  left: -70px;
  bottom: 0px;
  background-color: transparent;
  -webkit-transition: all 0.3s linear;
  -moz-transition: all 0.3s linear;
  -ms-transition: all 0.3s linear;
  -o-transition: all 0.3s linear;
  transition: all 0.3s linear;
}
body.fullscreen #resourcecontentview #filesViewSpan {
  margin-right: 25px;
  right: 0px;
}
#resourcecontentview #filesViewSpan,
body:not(.fullscreen) #resourcecontentview #metadataManagerDiv,
#resourcecontentview .card,
#resourcecontentview .card-body {
  height: 100%;
}
</style>

<style scoped>
input[type="file"] {
  display: none;
  font-size: 0px;
  position: absolute;
  left: 0;
  top: 0;
  opacity: 0;
}
.droppable {
  cursor: pointer;
  position: fixed; /* Sit on top of the page content */
  width: 100%; /* Full width (cover the whole page) */
  height: 100%; /* Full height (cover the whole page) */
  top: 0;
  left: 0;
  right: 0;
  bottom: 0;
  background-color: rgba(0, 0, 0, 0.5); /* Black background with opacity */
  z-index: 2; /* Specify a stack order in case you're using a different order for other elements */
  color: white;
  vertical-align: middle;
  text-align: center;
  font-size: 42pt;
}
.droppableText {
  margin-top: 9em;
  margin-left: 4em;
}
#resourcecontentview .card-body {
  padding-top: 8px;
  padding-bottom: 8px;
  padding-left: 0px;
  padding-right: 0px;
}
</style>
